using System.Collections.ObjectModel;
using System;
using System.ComponentModel;

public class ViewModel : INotifyPropertyChanged
    {
        public ObservableCollection<GridData> Data {get;set;}
        public ObservableCollection<string> RecDescs { get; set; }

        private GridData _activeItem;
        public GridData ActiveItem
        {
            get { return _activeItem; }
            set
            {
                if (_activeItem != value)
                {
                    _activeItem = value;
                    OnPropertyChanged("ActiveItem");
                }
            }
        }


       

        public ViewModel()
        {
            CreateData();
            
        }

        private string[] names = { "John", "Kim", "Sandy", "Mark", "Josh", "Jim", "Sam", "Mary", 
                                     "Harry", "Sue", "Chris", "Joe", "Carl" };
        private string[] recDescs = { "Duplicate", "Expired", "History","New", "Safe","Standard", "Test", "Trial"  };
        private void CreateData()
        {
            Random r = new Random();
            Data = new ObservableCollection<GridData>();
            for (int i = 0; i < 100; i++)
            {
                Data.Add(new GridData()
                {
                    ID = i,
                    Name = names[r.Next(13)],
                    RecDesc = recDescs[r.Next(8)],
                    RecDate = DateTime.Today.AddDays(r.Next(10))
                });
            }

            RecDescs = new ObservableCollection<string>();
            for (int i = 0; i < 7; i++)
            {
                RecDescs.Add(recDescs[i]);
            }
           
        }


        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

    }
    public class GridData : INotifyPropertyChanged
    {
        
        private int id;
        private string name;
        private DateTime recDt;
        private string rec_desc;


        public int ID
        {
            get { return id; }
            set
            {
                if (id != value)
                {
                    id = value;
                    OnPropertyChanged("ID");
                }
            }
        }

        public string Name
        {
            get { return name; }
            set
            {
                if (name != value)
                {
                    name = value;
                    OnPropertyChanged("Name");
                }
            }
        }

        public string RecDesc
        {
            get { return rec_desc; }
            set
            {
                if (rec_desc != value)
                {
                    rec_desc = value;
                    OnPropertyChanged("RecDesc");
                }
            }
        }

        public DateTime RecDate
        {
            get { return recDt; }
            set
            {
                if (recDt != value)
                {
                    recDt = value;
                    OnPropertyChanged("RecDate");
                }
            }
        }



        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }